Index: issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewMat.cpp	(revision 13975)
@@ -10,7 +10,7 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 #include "./petscpatches.h"
@@ -21,5 +21,5 @@
 
 /*NewMat(int M,int N){{{*/
-Mat NewMat(int M,int N){
+Mat NewMat(int M,int N,COMM comm){
 
 	/*output:*/
@@ -32,7 +32,7 @@
 
 	/*Determine local sizes: */
-	m=DetermineLocalSize(M);
-	n=DetermineLocalSize(N);
-	
+	m=DetermineLocalSize(M,comm);
+	n=DetermineLocalSize(N,comm);
+
 	nnz=(int)((double)M*(double)N*sparsity); //number of non zeros.
 	d_nz=(int)((double)nnz/(double)M/2.0); //number of non zeros per row/2
@@ -40,7 +40,7 @@
 
 	#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
-	MatCreateAIJ(MPI_COMM_WORLD,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
+	MatCreateAIJ(comm,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
 	#else
-	MatCreateMPIAIJ(MPI_COMM_WORLD,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
+	MatCreateMPIAIJ(comm,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
 	#endif
 
@@ -48,6 +48,6 @@
 }
 /*}}}*/
-/*NewMat(int M,int N,double sparsity){{{*/
-Mat NewMat(int M,int N,double sparsity){
+/*NewMat(int M,int N,double sparsity,COMM comm){{{*/
+Mat NewMat(int M,int N,double sparsity,COMM comm){
 
 	/*output:*/
@@ -60,7 +60,7 @@
 
 	/*Determine local sizes: */
-	m=DetermineLocalSize(M);
-	n=DetermineLocalSize(N);
-	
+	m=DetermineLocalSize(M,comm);
+	n=DetermineLocalSize(N,comm);
+
 	nnz=(int)((double)M*(double)N*sparsity); //number of non zeros.
 	d_nz=(int)((double)nnz/(double)M/2.0); //number of non zeros per row/2
@@ -69,11 +69,11 @@
 	#if _PETSC_MAJOR_ == 3 && _PETSC_MINOR_ > 2
 	if(sparsity==1){
-		MatCreateDense(MPI_COMM_WORLD,m,n,M,N,NULL,&outmatrix); 
+		MatCreateDense(comm,m,n,M,N,NULL,&outmatrix); 
 	}
 	else{
-		MatCreateAIJ(MPI_COMM_WORLD,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
+		MatCreateAIJ(comm,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
 	}
 	#else
-	MatCreateMPIAIJ(MPI_COMM_WORLD,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
+	MatCreateMPIAIJ(comm,m,n,M,N,d_nz,NULL,o_nz,NULL,&outmatrix); 
 	#endif
 
@@ -82,5 +82,5 @@
 /*}}}*/
 /*NewMat(int M,int N,int connectivity,int numberofdofspernode){{{*/
-Mat NewMat(int M,int N,int connectivity,int numberofdofspernode){
+Mat NewMat(int M,int N,int connectivity,int numberofdofspernode,COMM comm){
 
 	/*output:*/
@@ -90,8 +90,11 @@
 	int    m,n;
 	int    d_nz,o_nz;
-	int    nnz;
 
 	#if _PETSC_MAJOR_ >= 3 
+	#ifdef _HAVE_PETSCDEV_
+	MatType type;
+	#else
 	const MatType type;
+	#endif
 	#else
 	MatType type;
@@ -99,6 +102,6 @@
 
 	/*Determine local sizes: */
-	m=DetermineLocalSize(M);
-	n=DetermineLocalSize(N);
+	m=DetermineLocalSize(M,comm);
+	n=DetermineLocalSize(N,comm);
 
 	/*Figure out number of non zeros per row: */
@@ -106,5 +109,5 @@
 	o_nz=(int)connectivity*numberofdofspernode/2;
 
-	MatCreate(MPI_COMM_WORLD,&outmatrix);
+	MatCreate(comm,&outmatrix);
 	MatSetSizes(outmatrix,m,n,M,N);
 	MatSetFromOptions(outmatrix);
@@ -112,5 +115,5 @@
 	/*preallocation  according to type: */
 	MatGetType(outmatrix,&type);
-	
+
 	#if _PETSC_MAJOR_ == 2 
 	if((strcmp(type,"mpiaij")==0) || (strcmp(type,"aijmumps")==0)){
Index: issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/NewVec.cpp	(revision 13975)
@@ -17,7 +17,6 @@
 #include "../../mpi/patches/mpipatches.h"
 
-Vec NewVec(int size,bool fromlocalsize){
+Vec NewVec(int size,COMM comm,bool fromlocalsize){
 
-	int ierr;
 	int local_size;
 
@@ -30,9 +29,9 @@
 	}
 	else{
-		local_size=DetermineLocalSize(size);
+		local_size=DetermineLocalSize(size,comm);
 	}
-	
-	VecCreate(PETSC_COMM_WORLD,&vector); 
-	
+
+	VecCreate(comm,&vector); 
+
 	VecSetSizes(vector,local_size,PETSC_DECIDE); 
 	VecSetFromOptions(vector); 
Index: issm/trunk/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/PetscMatrixToDoubleMatrix.cpp	(revision 13975)
@@ -2,5 +2,4 @@
  * \brief: convert a sparse or dense Petsc matrix into a matlab matrix
  */
-
 
 #ifdef HAVE_CONFIG_H
@@ -13,29 +12,23 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 /*Petsc includes: */
 #include "../../../shared/shared.h"
 
-
 void PetscMatrixToDoubleMatrix(double** pmatrix, int* prows, int* pcols,Mat petsc_matrix){
 
-	int i,j,k;
-
 	/*output: */
+	int     i;
 	double* matrix=NULL;
 	int     rows,cols;
-
-	/*intermediary: */
-	int*    idxm=NULL;
-	int*    idxn=NULL;
 
 	/*Some needed information: */
 	MatGetSize(petsc_matrix,&rows,&cols);
 
-	idxm=xNew<int>(rows);
-	idxn=xNew<int>(cols);
+	int* idxm=xNew<int>(rows);
+	int* idxn=xNew<int>(cols);
 
 	for(i=0;i<rows;i++)idxm[i]=i;
Index: issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/PetscOptionsInsertMultipleString.cpp	(revision 13975)
@@ -10,7 +10,7 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 #include "./petscpatches.h"
@@ -20,5 +20,4 @@
 
 void PetscOptionsInsertMultipleString(char* options_string){
-
 
 	/*The list of options is going to be pairs of the type "-option option_value"*/
@@ -30,13 +29,9 @@
 	char* first=NULL;
 	char* second=NULL;
-	char* final=NULL;
 	size_t len;
-	int ignore_second;
 	int first_token=1;
-
 
 	PetscTokenCreate(options_string,' ',&token);
 	for (;;){
-		
 
 		/*Read next tokens*/
@@ -45,5 +40,5 @@
 		}
 		PetscTokenFind(token,&second);
-		
+
 		if (!first){
 			/*We are at the end of options*/
@@ -59,5 +54,5 @@
 			/*Reduce first to bare option value*/
 			PetscStrlen(first,&len);
-			while (len > 0 && (first[len-1] == ' ' || first[len-1] == 'n')) {
+			while (len > 0 && first[len-1] == ' ') {
 				len--; first[len] = 0;
 			}
@@ -70,5 +65,5 @@
 				/*Second is another option, ignore it*/
 				PetscStrlen(first,&len);
-				while (len > 0 && (first[len-1] == ' ' || first[len-1] == 'n')) {
+				while (len > 0 && first[len-1] == ' ' ) {
 					len--; first[len] = 0;
 				}
@@ -81,5 +76,5 @@
 				/*Second is 'first' option's value*/
 				PetscStrlen(second,&len);
-				while (len > 0 && (second[len-1] == ' ' || second[len-1] == 'n')) {
+				while (len > 0 && second[len-1] == ' ') {
 					len--; second[len] = 0;
 				}
Index: issm/trunk/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/PetscVectorToDoubleVector.cpp	(revision 13975)
@@ -11,7 +11,7 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 #include "../../../shared/shared.h"
@@ -19,7 +19,5 @@
 void PetscVectorToDoubleVector(double** pvector, int* prows, Vec petsc_vector){
 
-	int     i;
 	int     rows;
-	int    *idxm   = NULL;
 	double *vector = NULL;
 
@@ -28,7 +26,7 @@
 		VecGetSize(petsc_vector,&rows);
 		if(rows){
-			idxm=xNew<int>(rows);
+			int* idxm=xNew<int>(rows);
 			vector=xNew<double>(rows);
-			for(i=0;i<rows;i++)idxm[i]=i;
+			for(int i=0;i<rows;i++)idxm[i]=i;
 			VecGetValues(petsc_vector,rows,idxm,vector);
 			xDelete<int>(idxm);
Index: issm/trunk/src/c/toolkits/petsc/patches/VecDuplicatePatch.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecDuplicatePatch.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecDuplicatePatch.cpp	(revision 13975)
@@ -9,9 +9,8 @@
 #endif
 
-
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 void VecDuplicatePatch(Vec* output, Vec input){
Index: issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecFree.cpp	(revision 13975)
@@ -9,9 +9,8 @@
 #endif
 
-
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 void VecFree(Vec* pvec){
@@ -25,3 +24,2 @@
 
 }
-
Index: issm/trunk/src/c/toolkits/petsc/patches/VecMerge.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecMerge.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecMerge.cpp	(revision 13975)
@@ -10,7 +10,7 @@
 
 /*Petsc includes: */
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
 
 #include "./petscpatches.h"
@@ -21,6 +21,4 @@
 void VecMerge(Vec A, Vec B, double* row_partition_vector,int row_partition_size){
 
-	int i;
-	
 	/*Petsc matrix*/
 	int lower_row,upper_row,range;
@@ -29,10 +27,10 @@
 
 	/*Vector sizes: */
-	int MA,MB;
+	int MB;
 
 	VecGetSize(B,&MB);
 
 	/*If the dimension of the partitioning vector is not the same as that of vector B, we have a problem: */
-	if ( (row_partition_size !=MB) ){
+	if ((row_partition_size !=MB) ){
 		_error_("Dimensions of partitioning vector incompatible with dimensions of input vector\n");
 	}
@@ -47,15 +45,15 @@
 		idxm=xNew<int>(range);
 		values=xNew<double>(range);
-		for (i=0;i<range;i++){
-			*(idxm+i)=lower_row+i;
+		for(int i=0;i<range;i++){
+			idxm[i]=lower_row+i;
 		}
 		VecGetValues(B,range,idxm,values);
 		/*Now, modify idxm using the partition vector, and plug values into A*/
-		for (i=0;i<range;i++){
-			*(idxm+i)=(int)*(row_partition_vector+lower_row+i)-1; //-1 because partition vector comes from Matlab, where indices start at 1.
+		for(int i=0;i<range;i++){
+			idxm[i]=int(row_partition_vector[lower_row+i])-1; //-1 because partition vector comes from Matlab, where indices start at 1.
 		}
 		VecSetValues(A,range,idxm,values,INSERT_VALUES);
 	}
-	
+
 	/*Assemble vector*/
 	VecAssemblyBegin(A);
Index: issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/VecToMPISerial.cpp	(revision 13975)
@@ -9,13 +9,12 @@
 #endif
 
-
 #include "../petscincludes.h"
 #include "../../../shared/shared.h"
 
-int VecToMPISerial(double** pgathered_vector, Vec vector){
-	
+int VecToMPISerial(double** pgathered_vector, Vec vector,COMM comm){
+
 	int i;
-	extern int num_procs; 
-	extern int my_rank;
+	int num_procs; 
+	int my_rank;
 
 	/*Petsc*/
@@ -25,5 +24,5 @@
 	int * idxn=NULL; 
 	int buffer[3];
-	
+
 	/*intermediary results*/
 	double* local_vector=NULL;
@@ -31,7 +30,11 @@
 	/*input*/
 	int vector_size;
-	
+
 	/*Output*/
 	double* gathered_vector=NULL; //Global vector holding the final assembled vector on all nodes.
+
+	/*recover my_rank and num_procs*/
+	MPI_Comm_size(comm,&num_procs);
+	MPI_Comm_rank(comm,&my_rank);
 
 	VecGetSize(vector,&vector_size);
@@ -43,5 +46,5 @@
 	/*Allocate gathered vector on all nodes .*/
 	gathered_vector=xNew<double>(vector_size);
-	
+
 	/*Allocate local vectors*/
 	VecGetOwnershipRange(vector,&lower_row,&upper_row);
@@ -66,10 +69,10 @@
 			buffer[1]=lower_row;
 			buffer[2]=range;
-			MPI_Send(buffer,3,MPI_INT,0,1,MPI_COMM_WORLD);  
-			if (range)MPI_Send(local_vector,range,MPI_DOUBLE,0,1,MPI_COMM_WORLD); 
+			MPI_Send(buffer,3,MPI_INT,0,1,comm);  
+			if (range)MPI_Send(local_vector,range,MPI_DOUBLE,0,1,comm); 
 		}
 		if (my_rank==0){
-			MPI_Recv(buffer,3,MPI_INT,i,1,MPI_COMM_WORLD,&status); 
-			if (buffer[2])MPI_Recv(gathered_vector+buffer[1],buffer[2],MPI_DOUBLE,i,1,MPI_COMM_WORLD,&status);
+			MPI_Recv(buffer,3,MPI_INT,i,1,comm,&status); 
+			if (buffer[2])MPI_Recv(gathered_vector+buffer[1],buffer[2],MPI_DOUBLE,i,1,comm,&status);
 		}
 	}
@@ -81,13 +84,13 @@
 
 	/*Now, broadcast gathered_vector from node 0 to other nodes: */
-	MPI_Bcast(gathered_vector,vector_size,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	MPI_Bcast(gathered_vector,vector_size,MPI_DOUBLE,0,comm);
 
 	/*Assign output pointers: */
 	*pgathered_vector=gathered_vector;
-	
+
 	/*free ressources: */
 	xDelete<int>(idxn);
 	xDelete<double>(local_vector);
-	
+
 	return 1;
 }
Index: issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h
===================================================================
--- issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/petsc/patches/petscpatches.h	(revision 13975)
@@ -6,40 +6,37 @@
 #define _PETSC_PATCHES_H_
 
-#include "petscmat.h"
-#include "petscvec.h"
-#include "petscksp.h"
-#include "petscsys.h"
+#include <petscmat.h>
+#include <petscvec.h>
+#include <petscksp.h>
+#include <petscsys.h>
 
 #include "./SolverEnum.h"
 #include "../../toolkitsenums.h"
+#include "../../../include/types.h"
 
 class Parameters;
 
-Vec NewVec(int size,bool fromlocalsize=false);
-Mat NewMat(int M,int N);
-Mat NewMat(int M,int N,double sparsity);
-Mat NewMat(int M,int N,int connectivity,int numberofdofspernode);
+Vec NewVec(int size,COMM comm,bool fromlocalsize=false);
+Mat NewMat(int M,int N,COMM comm);
+Mat NewMat(int M,int N,double sparsity,COMM comm);
+Mat NewMat(int M,int N,int connectivity,int numberofdofspernode, COMM comm);
 
-int VecTranspose(Vec* tvector,Vec vector);
-int VecToMPISerial(double** pgathered_vector, Vec vector);
-void GetOwnershipBoundariesFromRange(int* plower_row,int* pupper_row,int range);
+int VecToMPISerial(double** pgathered_vector, Vec vector,COMM comm);
 void MatFree(Mat* pmat);
 void ISFree(IS* pis);
 void VecFree(Vec* pvec);
 void KSPFree(KSP* pksp);
-void VecPartition(Vec* poutvector,Vec vectorA, double* row_partition_vector, int row_partition_vector_size,bool kffpartitioning);
 int MatPartition(Mat* poutmatrix,Mat matrixA,double* row_partition_vector,int row_partition_vector_size ,
 		double* col_partition_vector,int col_partition_vector_size);
-void MatInvert(Mat* pInv, Mat Matrix);
 void PetscOptionsInsertMultipleString(char* options_string);
 void PetscOptionsDetermineSolverType(int* psolver_type);
 void VecMerge(Vec A, Vec B, double* row_partition_vector,int row_partition_size);
-void MatMultPatch(Mat A,Vec X, Vec AX);
-void MatToSerial(double** poutmatrix,Mat matrix);
+void MatMultPatch(Mat A,Vec X, Vec AX,COMM comm);
+void MatToSerial(double** poutmatrix,Mat matrix,COMM comm);
 void VecDuplicatePatch(Vec* output, Vec input);
 Vec  SerialToVec(double* vector,int vector_size);
 InsertMode ISSMToPetscInsertMode(InsMode mode);
 NormType ISSMToPetscNormMode(NormMode mode);
-MatType ISSMToPetscMatrixType(MatrixType type);
+const MatType ISSMToPetscMatrixType(MatrixType type);
 
 void PetscMatrixToDoubleMatrix(double** pmatrix, int* prows, int* pcols,Mat matrix);
Index: issm/trunk/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp
===================================================================
--- issm/trunk/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/plapack/patches/CyclicalFactorization.cpp	(revision 13975)
@@ -3,5 +3,4 @@
 */
 #include <math.h>
-
 
 #include "../../../shared/shared.h"
@@ -10,5 +9,5 @@
 
 int CyclicalFactorization(int* pnprows,int* pnpcols,int num_procs){
-	
+
 	int nprows,npcols;
 	int last_diff;
@@ -40,9 +39,8 @@
 int PrimeDecomp(int** pdecomp,int* pdecomp_size,int input){
 
-	int* decomp=NULL;
 	int prime_factor;
 	int i;
 
-	decomp=xNew<int>(input);
+	int* decomp=xNew<int>(input);
 	*decomp=input;
 	for (i=0;i<input;i++){
@@ -65,5 +63,5 @@
 */
 int SmallestPrimeFactor(int* output,int input){
-	
+
 	int found=0;
 	int i;
Index: issm/trunk/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp
===================================================================
--- issm/trunk/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/plapack/patches/PlapackInvertMatrix.cpp	(revision 13975)
@@ -14,17 +14,17 @@
 
 void PlapackInvertMatrixLocalCleanup(PLA_Obj* pa,PLA_Template* ptempl,double** parrayA,int** pidxnA,MPI_Comm* pcomm_2d);
-	
-int PlapackInvertMatrix(Mat* A,Mat* inv_A,int status,int con){ 
+
+int PlapackInvertMatrix(Mat* A,Mat* inv_A,int status,int con,COMM comm){ 
 	/*inv_A does not yet exist, inv_A was just allocated, that's all*/
 
 	/*Error management*/
-	int i,j;
+	int i;
 
 	/*input*/
 	int mA,nA;
 	int local_mA,local_nA;
-	int lower_row,upper_row,range,this_range,this_lower_row;
+	int lower_row,upper_row;
 	MatType type;
-	
+
 	/*Plapack: */
 	MPI_Datatype   datatype;
@@ -36,13 +36,8 @@
 	int nb,nb_alg;
 	int nprows,npcols;
-	int initialized=0;
 
 	/*Petsc to Plapack: */
 	double    *arrayA=NULL;
 	int* idxnA=NULL;
-	int d_nz,o_nz;
-	
-	/*Feedback to client*/
-	int computation_status;  
 
 	/*Verify that A is square*/
@@ -76,5 +71,5 @@
 	if(PLA_Initialized(NULL)==TRUE)PLA_Finalize();
 	/* Create a 2D communicator */
-	PLA_Comm_1D_to_2D(MPI_COMM_WORLD,nprows,npcols,&comm_2d); 
+	PLA_Comm_1D_to_2D(comm,nprows,npcols,&comm_2d); 
 
 	/*Initlialize plapack: */
@@ -92,5 +87,5 @@
 	/* Set the datatype */
 	datatype = MPI_DOUBLE;
-	
+
 	/* Copy A into a*/
 	PLA_Matrix_create(datatype,mA,nA,templ,PLA_ALIGN_FIRST,PLA_ALIGN_FIRST,&a);  
@@ -100,5 +95,4 @@
 	MatGetOwnershipRange(*A,&lower_row,&upper_row);
 	upper_row--; 
-	range=upper_row-lower_row+1;
 	arrayA = xNew<double>(nA);
 	idxnA  = xNew<int>(nA);
@@ -127,5 +121,5 @@
 	xDelete<double>(arrayA);
 	xDelete<int>(idxnA);
-	
+
 	/*Finalize PLAPACK*/
 	PLA_Finalize();
Index: issm/trunk/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp
===================================================================
--- issm/trunk/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp	(revision 13405)
+++ issm/trunk/src/c/toolkits/plapack/patches/PlapackToPetsc.cpp	(revision 13975)
@@ -6,10 +6,9 @@
 #include "../plapackincludes.h"
 
-int PlapackToPetsc(Mat* A,int local_mA,int local_nA,int mA,int nA,MatType type,PLA_Obj a,PLA_Template templ,int nprows,int npcols,int nb){
+int PlapackToPetsc(Mat* A,int local_mA,int local_nA,int mA,int nA,MatType type,PLA_Obj a,PLA_Template templ,int nprows,int npcols,int nb,COMM comm){
 
-	
 	int i;
 
-	int lower_row,upper_row,range;
+	int lower_row,upper_row;
 	int* row_nodes=NULL;
 	int* col_nodes=NULL;
@@ -22,5 +21,4 @@
 	double* local_buffer=NULL;
 
-
 	/*Create matrix A (right now, we just have an allocated pointer A*/
 	if (strcasecmp_eq(type,MATMPIAIJ)){
@@ -28,14 +26,13 @@
 		d_nz=nA/2;
 		o_nz=nA/2;
-		MatCreateMPIAIJ(MPI_COMM_WORLD,local_mA,local_nA, mA,nA,d_nz,PETSC_NULL,o_nz,PETSC_NULL,A);
+		MatCreateMPIAIJ(comm,local_mA,local_nA, mA,nA,d_nz,PETSC_NULL,o_nz,PETSC_NULL,A);
 	}
 	else if(strcasecmp_eq(type,MATMPIDENSE)){
-		MatCreateMPIDense(MPI_COMM_WORLD,local_mA,local_nA, mA,nA,PETSC_NULL,A); 
+		MatCreateMPIDense(comm,local_mA,local_nA, mA,nA,PETSC_NULL,A); 
 	}
-	
+
 	MatGetOwnershipRange(*A,&lower_row,&upper_row);
 	upper_row--;
-	range=upper_row-lower_row+1;
-	
+
 	/*Build the Plapack row and column indices corresponding to the local_buffer stored in a. 
 	  We need those indices to directly plug local_buffer into the Petsc matrix A. We do not 
@@ -43,5 +40,5 @@
 	  problem size becomes big. We rely therefore on MatAssembly from Petsc to gather the plapack 
 	  matrix into a Petsc Matrix.*/
-	
+
 	/*Vector physically based block cyclic distribution: */
 	row_nodes=xNew<int>(mA);
@@ -82,5 +79,5 @@
 	/*Get local buffer: */
 	PLA_Obj_local_buffer(a,(void**)&local_buffer);
-	
+
 	/*Insert into invA matrix. Use col oriented insertion, for Plapack is column oriented*/
 	MatSetOption(*A,MAT_COLUMN_ORIENTED);
Index: issm/trunk/src/c/toolkits/plapack/patches/plapackpatches.h
===================================================================
--- issm/trunk/src/c/toolkits/plapack/patches/plapackpatches.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/plapack/patches/plapackpatches.h	(revision 13975)
@@ -6,6 +6,6 @@
 #define _PLAPACK_PATCHES_H_
 
-int PlapackInvertMatrix(Mat* A,Mat* inv_A,int status,int con);
-int PlapackToPetsc(Mat* A,int local_mA,int local_nA,int mA,int nA,MatType type,PLA_Obj a,PLA_Template templ,int nprows,int npcols,int nb);
+int PlapackInvertMatrix(Mat* A,Mat* inv_A,int status,int con,COMM comm);
+int PlapackToPetsc(Mat* A,int local_mA,int local_nA,int mA,int nA,MatType type,PLA_Obj a,PLA_Template templ,int nprows,int npcols,int nb,COMM comm);
 int CyclicalFactorization(int* pnprows,int* pnpcols,int num_procs);
 
Index: issm/trunk/src/c/toolkits/plapack/plapackincludes.h
===================================================================
--- issm/trunk/src/c/toolkits/plapack/plapackincludes.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/plapack/plapackincludes.h	(revision 13975)
@@ -12,6 +12,5 @@
 #endif
 
-
-#include "PLA.h"
+#include <PLA.h>
 
 /* missing Plapack prototypes: */
@@ -20,8 +19,6 @@
 /*our own patches: */
 #ifdef _HAVE_PETSC_
-#include "patches/petscpatches.h"
+#include "./patches/petscpatches.h"
 #endif
 
-
 #endif
-
Index: issm/trunk/src/c/toolkits/toolkits.h
===================================================================
--- issm/trunk/src/c/toolkits/toolkits.h	(revision 13405)
+++ issm/trunk/src/c/toolkits/toolkits.h	(revision 13975)
@@ -10,8 +10,4 @@
 #else
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
-#endif
-
-#ifdef _HAVE_PYTHON_
-#include "./python/pythonincludes.h"
 #endif
 
@@ -31,4 +27,3 @@
 #include "./toolkitsenums.h"
 #include "./issm/issmtoolkit.h"
-
 #endif
Index: issm/trunk/src/dox/issm.dox
===================================================================
--- issm/trunk/src/dox/issm.dox	(revision 13405)
+++ issm/trunk/src/dox/issm.dox	(revision 13975)
@@ -46,17 +46,17 @@
 </th>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> C++ </th><td  bgcolor=#FFFFFF style="text-align:right;">508</td><td  bgcolor=#FFFFFF style="text-align:right;">14595</td><td  bgcolor=#FFFFFF style="text-align:right;">16762</td><td  bgcolor=#FFFFFF style="text-align:right;">56036</td><td  bgcolor=#FFFFFF style="text-align:right;">87393</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> C++ </th><td  bgcolor=#FFFFFF style="text-align:right;">505</td><td  bgcolor=#FFFFFF style="text-align:right;">14316</td><td  bgcolor=#FFFFFF style="text-align:right;">16564</td><td  bgcolor=#FFFFFF style="text-align:right;">56522</td><td  bgcolor=#FFFFFF style="text-align:right;">87402</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> MATLAB </th><td  bgcolor=#C6E2FF style="text-align:right;">925</td><td  bgcolor=#C6E2FF style="text-align:right;">6851</td><td  bgcolor=#C6E2FF style="text-align:right;">13228</td><td  bgcolor=#C6E2FF style="text-align:right;">30468</td><td  bgcolor=#C6E2FF style="text-align:right;">50547</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> MATLAB </th><td  bgcolor=#C6E2FF style="text-align:right;">913</td><td  bgcolor=#C6E2FF style="text-align:right;">6625</td><td  bgcolor=#C6E2FF style="text-align:right;">13054</td><td  bgcolor=#C6E2FF style="text-align:right;">30160</td><td  bgcolor=#C6E2FF style="text-align:right;">49839</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> C/C++  Header </th><td  bgcolor=#FFFFFF style="text-align:right;">378</td><td  bgcolor=#FFFFFF style="text-align:right;">2758</td><td  bgcolor=#FFFFFF style="text-align:right;">2612</td><td  bgcolor=#FFFFFF style="text-align:right;">9818</td><td  bgcolor=#FFFFFF style="text-align:right;">15188</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> C/C++  Header </th><td  bgcolor=#FFFFFF style="text-align:right;">388</td><td  bgcolor=#FFFFFF style="text-align:right;">3069</td><td  bgcolor=#FFFFFF style="text-align:right;">2983</td><td  bgcolor=#FFFFFF style="text-align:right;">11855</td><td  bgcolor=#FFFFFF style="text-align:right;">17907</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> m4 </th><td  bgcolor=#C6E2FF style="text-align:right;">7</td><td  bgcolor=#C6E2FF style="text-align:right;">997</td><td  bgcolor=#C6E2FF style="text-align:right;">80</td><td  bgcolor=#C6E2FF style="text-align:right;">8259</td><td  bgcolor=#C6E2FF style="text-align:right;">9336</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> m4 </th><td  bgcolor=#C6E2FF style="text-align:right;">6</td><td  bgcolor=#C6E2FF style="text-align:right;">1052</td><td  bgcolor=#C6E2FF style="text-align:right;">79</td><td  bgcolor=#C6E2FF style="text-align:right;">8993</td><td  bgcolor=#C6E2FF style="text-align:right;">10124</td>
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> Python </th><td  bgcolor=#FFFFFF style="text-align:right;">53</td><td  bgcolor=#FFFFFF style="text-align:right;">400</td><td  bgcolor=#FFFFFF style="text-align:right;">610</td><td  bgcolor=#FFFFFF style="text-align:right;">1424</td><td  bgcolor=#FFFFFF style="text-align:right;">2434</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> Python </th><td  bgcolor=#FFFFFF style="text-align:right;">81</td><td  bgcolor=#FFFFFF style="text-align:right;">2677</td><td  bgcolor=#FFFFFF style="text-align:right;">3936</td><td  bgcolor=#FFFFFF style="text-align:right;">5169</td><td  bgcolor=#FFFFFF style="text-align:right;">11782</td>
 </tr>
 <tr>
@@ -64,8 +64,8 @@
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> Perl </th><td  bgcolor=#FFFFFF style="text-align:right;">3</td><td  bgcolor=#FFFFFF style="text-align:right;">21</td><td  bgcolor=#FFFFFF style="text-align:right;">23</td><td  bgcolor=#FFFFFF style="text-align:right;">240</td><td  bgcolor=#FFFFFF style="text-align:right;">284</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> Bourne  Shell </th><td  bgcolor=#FFFFFF style="text-align:right;">5</td><td  bgcolor=#FFFFFF style="text-align:right;">58</td><td  bgcolor=#FFFFFF style="text-align:right;">81</td><td  bgcolor=#FFFFFF style="text-align:right;">268</td><td  bgcolor=#FFFFFF style="text-align:right;">407</td>
 </tr>
 <tr>
-<th  bgcolor=#C6E2FF style="text-align:left;"> Bourne  Shell </th><td  bgcolor=#C6E2FF style="text-align:right;">5</td><td  bgcolor=#C6E2FF style="text-align:right;">47</td><td  bgcolor=#C6E2FF style="text-align:right;">75</td><td  bgcolor=#C6E2FF style="text-align:right;">239</td><td  bgcolor=#C6E2FF style="text-align:right;">361</td>
+<th  bgcolor=#C6E2FF style="text-align:left;"> Perl </th><td  bgcolor=#C6E2FF style="text-align:right;">3</td><td  bgcolor=#C6E2FF style="text-align:right;">21</td><td  bgcolor=#C6E2FF style="text-align:right;">23</td><td  bgcolor=#C6E2FF style="text-align:right;">240</td><td  bgcolor=#C6E2FF style="text-align:right;">284</td>
 </tr>
 <tr>
@@ -76,5 +76,5 @@
 </tr>
 <tr>
-<th  bgcolor=#FFFFFF style="text-align:left;"> SUM: </th><td  bgcolor=#FFFFFF style="text-align:right;">1890</td><td  bgcolor=#FFFFFF style="text-align:right;">25787</td><td  bgcolor=#FFFFFF style="text-align:right;">33397</td><td  bgcolor=#FFFFFF style="text-align:right;">106984</td><td  bgcolor=#FFFFFF style="text-align:right;">166168</td>
+<th  bgcolor=#FFFFFF style="text-align:left;"> SUM: </th><td  bgcolor=#FFFFFF style="text-align:right;">1912</td><td  bgcolor=#FFFFFF style="text-align:right;">27936</td><td  bgcolor=#FFFFFF style="text-align:right;">36727</td><td  bgcolor=#FFFFFF style="text-align:right;">113707</td><td  bgcolor=#FFFFFF style="text-align:right;">178370</td>
 </tr>
 </table>
Index: issm/trunk/src/m/Makefile.am
===================================================================
--- issm/trunk/src/m/Makefile.am	(revision 13405)
+++ issm/trunk/src/m/Makefile.am	(revision 13975)
@@ -3,4 +3,5 @@
 #find . -type d -exec ls -d {} \;
 
+if WRAPPERS
 bin_SCRIPTS= ./qmu/*.m \
 				 ./qmu/setupdesign/*.m \
@@ -49,2 +50,3 @@
 				 ./solvers/*.m \
 				 ./materials/*.m
+endif
Index: issm/trunk/src/m/array/str2int.m
===================================================================
--- issm/trunk/src/m/array/str2int.m	(revision 13405)
+++ issm/trunk/src/m/array/str2int.m	(revision 13975)
@@ -5,5 +5,5 @@
 %  function [aint]=str2int(astr,cfl)
 %
-function [aint]=str2int(astr,cfl);
+function [aint]=str2int(astr,cfl)
 
 aint=[];
@@ -44,3 +44,2 @@
 
 end
-
Index: issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m
===================================================================
--- issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m	(revision 13405)
+++ issm/trunk/src/m/boundaryconditions/SetIceSheetBC.m	(revision 13975)
@@ -58,5 +58,5 @@
 	pos=find(md.mesh.vertexonsurface); md.thermal.spctemperature(pos)=md.initialization.temperature(pos); %impose observed temperature on surface
 	if (length(md.basalforcings.geothermalflux)~=md.mesh.numberofvertices),
-		md.basalforcings.geothermalflux=50*10^-3*ones(md.mesh.numberofvertices,1); %50 mW/m^2
+		md.basalforcings.geothermalflux=50.*10^-3*ones(md.mesh.numberofvertices,1); %50 mW/m^2
 	end
 else
